local AddName, AddonTable = ...
local L = AddonTable.L

------------------------------
--		Options Equates		--
------------------------------
local Both, Enhanced, Base, Damage, DamageTaken, Percentage, Rating, MainHand, OffHand, SameLevel, BossLevel, Regen, Casting, Critical, CritDamage, Total, Max, Average = 3, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 1, 2

------------------------------
--		Global Updater		--
------------------------------

AddonTable.critSpellChance, AddonTable.hitSpell, AddonTable.hitSpellRating, AddonTable.regenBase, AddonTable.regenCasting, AddonTable.critSpellBase, AddonTable.regenBaseBasic, AddonTable.regenCastingBasic  = 0, 0, 0, 0, 0, 0, 0, 0

function AddonTable.SpellUpdate()

 	AddonTable.targetLevel = AddonTable.playerLevel + 3
	if UnitCanAttack("player", "target") then
		AddonTable.targetLevel = UnitLevel("target")
		if AddonTable.targetLevel <= 0 then
			AddonTable.targetLevel = AddonTable.playerLevel + 3
		end
	end

	-- Critical
	AddonTable.critSpellChance = 0
	AddonTable.critSpellBase = 0
	local holySchool = GetSpellCritChance(2)
	local fireSchool = GetSpellCritChance(3)
	local natureSchool = GetSpellCritChance(4)
	local frostSchool = GetSpellCritChance(5)
	local shadowSchool = GetSpellCritChance(6)
	local arcaneSchool = GetSpellCritChance(7)

	AddonTable.critSpellChance = max(holySchool, fireSchool, natureSchool, frostSchool, shadowSchool, arcaneSchool)
	AddonTable.critSpellBase = AddonTable.critSpellChance
	AddonTable.critSpellChance = AddonTable.critSpellChance + AddonTable.combustionCount + AddonTable.tidalMastery + AddonTable.starlight + AddonTable.masterImp +
	AddonTable.masterSucc + AddonTable.totemWrath + AddonTable.innerFocus + AddonTable.heartCrusader + AddonTable.wintersChill + AddonTable.impSorch + AddonTable.impShadowbolt + AddonTable.faerieCrit
	
	AddonTable.impDemonicTactics = AddonTable.critSpellChance * AddonTable.ImpDemonicTactics
	
	if AddonTable.faerieFireImp > AddonTable.misery then AddonTable.misery = 0 end

	-- Hit
	AddonTable.hitSpell = GetCombatRatingBonus(CR_HIT_SPELL)
	AddonTable.hitSpellRating = GetCombatRating(CR_HIT_SPELL)
	AddonTable.hitSpell = AddonTable.hitSpell + AddonTable.hitMod + AddonTable.elePrecision + AddonTable.balancePower + AddonTable.heroicPresence + AddonTable.arcaneFocus +
	AddonTable.Suppression + AddonTable.virulence + AddonTable.misery + AddonTable.faerieFireImp
	
	-- MP2
	local notcasting = 0
	local tempRegen = 0
	AddonTable.regenBase, AddonTable.regenCasting = GetManaRegen()

	AddonTable.regenBase = AddonTable.regenBase * 2
	AddonTable.regenCasting = (AddonTable.regenCasting * 2)

	if AddonTable.regenBase == AddonTable.regenCasting then
		if notcasting then
			AddonTable.regenBase = notcasting
		end
	else
		notcasting = AddonTable.regenBase
	end
	
	AddonTable.regenBaseBasic = AddonTable.regenBase
	AddonTable.regenCastingBasic = AddonTable.regenCasting

	tempRegen = AddonTable.felEnergy + (AddonTable.epiphany * 0.4) + AddonTable.manaTide + ((AddonTable.aspectViper/3) * 2)

	AddonTable.regenCasting = AddonTable.regenCasting + tempRegen + (AddonTable.innervate * 2)
	AddonTable.regenBase = AddonTable.regenBase + AddonTable.felEnergy + AddonTable.evoc + (AddonTable.epiphany * 0.4) + AddonTable.manaTide + ((AddonTable.aspectViper/3) * 2) + (AddonTable.innervate * 2)
	
end
-------------------------------------------------

-- Healing
function AddonTable.FunctionList.Healing(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local healSpell = GetSpellBonusHealing()
	local healBase = healSpell
	local decimals
	local returnText

	healSpell = (healSpell + (healSpell * AddonTable.spiritualHealing) + (healSpell * AddonTable.avenWrath) + (healSpell * AddonTable.giftNature) + (healSpell * AddonTable.purification) + (healSpell * AddonTable.blessedResil) + 
				(healSpell * AddonTable.divinity) + (healSpell * AddonTable.treeofLife) + (healSpell * AddonTable.FocusedPower))	
	
	if options.Dec_Spell_Healing == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Healing == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Healing == 2 then decimals = "%.2f"
	else decimals = "%.3f" end
	
	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(healSpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(healBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(healSpell) .. " (" .. (decimals):format(healBase) .. ")" end
	if returnText == nil then returnText = "" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Holy
function AddonTable.FunctionList.Holy(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local holySpell = GetSpellBonusDamage(2)
	local holyBase = holySpell
	local decimals
	local returnText

	holySpell = (holySpell + (holySpell * AddonTable.vengBuff) + (holySpell * AddonTable.avenWrath) + (holySpell * AddonTable.zoneBuff) + (holySpell * AddonTable.crusadeTalent) + 
	(holySpell * (AddonTable.masterFel / 100)) + (holySpell * AddonTable.curseElements) + (holySpell * AddonTable.ebonPlague) + (holySpell * AddonTable.earthMoon) + (holySpell * AddonTable.FocusedPower) +
	(holySpell * AddonTable.arcaneEmpowerment) + (holySpell * AddonTable.feroInspiration) + (holySpell * AddonTable.BeastSlaying))
	
	if options.Dec_Spell_Holy == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Holy == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Holy == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(holySpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(holyBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(holySpell) .. " (" .. (decimals):format(holyBase) .. ")" end
	if returnText == nil then returnText = "" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Nature
function AddonTable.FunctionList.Nature(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local natureSpell = GetSpellBonusDamage(4)
	local natureBase = natureSpell
	local decimals
	local returnText	

	natureSpell = (natureSpell + (natureSpell * AddonTable.stormStrike) + (natureSpell * AddonTable.zoneBuff) + (natureSpell * AddonTable.curseElements) + 
	(natureSpell * AddonTable.ebonPlague) + (natureSpell * AddonTable.earthMoon) + (natureSpell * AddonTable.arcaneEmpowerment) + (natureSpell * AddonTable.feroInspiration) + (natureSpell * AddonTable.BeastSlaying))
	
	if options.Dec_Spell_Nature == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Nature == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Nature == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(natureSpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(natureBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(natureSpell) .. " (" .. (decimals):format(natureBase) .. ")" end	
	if returnText == nil then returnText = "" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Shadow
function AddonTable.FunctionList.Shadow(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local shadowSpell = GetSpellBonusDamage(6)
	local shadowBase = shadowSpell
	local decimals
	local returnText
	
	shadowSpell = (shadowSpell + (shadowSpell * AddonTable.DarkNessTalent) + (shadowSpell * AddonTable.dsSuc) + (shadowSpell * AddonTable.zoneBuff) +
	(shadowSpell * AddonTable.shadowFormDmg) + (shadowSpell * AddonTable.shadowWeaving) + (shadowSpell * AddonTable.curseElements) + (shadowSpell * AddonTable.shadowMastery) +
	(shadowSpell * (AddonTable.masterSucc / 100)) + (shadowSpell * (AddonTable.masterFel / 100)) + (shadowSpell * AddonTable.ebonPlague) + (shadowSpell * AddonTable.earthMoon) + (shadowSpell * AddonTable.FocusedPower) +
	(shadowSpell * AddonTable.arcaneEmpowerment) + (shadowSpell * AddonTable.feroInspiration) + (shadowSpell * AddonTable.BeastSlaying) + (shadowSpell * AddonTable.DemonicPact) + (shadowSpell * AddonTable.metaDamage))

	if options.Dec_Spell_Shadow == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Shadow == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Shadow == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(shadowSpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(shadowBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(shadowSpell) .. " (" .. (decimals):format(shadowBase) .. ")" end
	if returnText == nil then returnText = "" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Fire
function AddonTable.FunctionList.Fire(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local fireSpell = GetSpellBonusDamage(3)
	local fireBase = fireSpell
	local decimals
	local returnText

	fireSpell = (fireSpell + (fireSpell * AddonTable.aiMod) + (fireSpell * AddonTable.zoneBuff) + (fireSpell * AddonTable.emberstorm) + (fireSpell * AddonTable.dsImp) + (fireSpell * AddonTable.playFire) +
	(fireSpell * AddonTable.arcanePower) + (fireSpell * AddonTable.curseElements) + (fireSpell * (AddonTable.masterImp / 100)) + (fireSpell * (AddonTable.masterFel / 100)) + (fireSpell * AddonTable.ebonPlague) + 
	(fireSpell * AddonTable.earthMoon) + (fireSpell * AddonTable.moltenFury) + (fireSpell * AddonTable.arcaneEmpowerment) + (fireSpell * AddonTable.arcanePower) + (fireSpell * AddonTable.feroInspiration) + 
	(fireSpell * AddonTable.BeastSlaying) + (fireSpell * AddonTable.DemonicPact) + (fireSpell * AddonTable.metaDamage))

	if options.Dec_Spell_Fire == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Fire == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Fire == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(fireSpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(fireBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(fireSpell) .. " (" .. (decimals):format(fireBase) .. ")" end
	if returnText == nil then returnText = "" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Frost
function AddonTable.FunctionList.Frost(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local frostSpell = GetSpellBonusDamage(5)
	local frostBase = frostSpell
	local decimals
	local returnText	

	frostSpell = (frostSpell + (frostSpell * AddonTable.pierceMod) + (frostSpell * AddonTable.aiMod) + (frostSpell * AddonTable.zoneBuff) + (frostSpell * AddonTable.playFire) + 
	(frostSpell * AddonTable.impFrostbolt) + (frostSpell * AddonTable.arcticWind) + (frostSpell * (AddonTable.masterFel / 100)) + (frostSpell * AddonTable.arcanePower) +
	(frostSpell * AddonTable.curseElements) + (frostSpell * AddonTable.ebonPlague) + (frostSpell * AddonTable.earthMoon) + (frostSpell * AddonTable.moltenFury) + 
	(frostSpell * AddonTable.arcaneEmpowerment) + (frostSpell * AddonTable.arcanePower) + (frostSpell * AddonTable.feroInspiration) + (frostSpell * AddonTable.BeastSlaying))

	if options.Dec_Spell_Frost == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Frost == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Frost == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(frostSpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(frostBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(frostSpell) .. " (" .. (decimals):format(frostBase) .. ")" end
	if returnText == nil then returnText = "" end

	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Arcane
function AddonTable.FunctionList.Arcane(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local arcaneSpell = GetSpellBonusDamage(7)
	local arcaneBase = arcaneSpell
	local decimals
	local returnText	

	arcaneSpell = (arcaneSpell + (arcaneSpell * AddonTable.aiMod) + (arcaneSpell * AddonTable.arcanePower) + (arcaneSpell * AddonTable.playFire) + (arcaneSpell * AddonTable.zoneBuff) + 
	(arcaneSpell * (AddonTable.masterFel / 100)) + (arcaneSpell * AddonTable.curseElements) + (arcaneSpell * AddonTable.ebonPlague) + (arcaneSpell * AddonTable.earthMoon) + (arcaneSpell * AddonTable.moltenFury) + 
	(arcaneSpell * AddonTable.arcaneEmpowerment) + (arcaneSpell * AddonTable.arcanePower) + (arcaneSpell * AddonTable.feroInspiration) + (arcaneSpell * AddonTable.BeastSlaying))

	if options.Dec_Spell_Arcane == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Arcane == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Arcane == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(arcaneSpell) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(arcaneBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(arcaneSpell) .. " (" .. (decimals):format(arcaneBase) .. ")" end
	if returnText == nil then returnText = "" end

	HUD:UpdateText(data, returnText)
end
------------------------------------------------
 
-- Critical
function AddonTable.FunctionList.SpellCrit(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Percent_Rating
	local critSpellRating = GetCombatRating(CR_CRIT_SPELL)
	local returnText, decimals, liveCrit

	if options.Display_Basic then AddonTable.critSpellChance = AddonTable.critSpellBase end
	if options.Dec_Spell_Crit == 0 then decimals = "%.0f%%"
	elseif options.Dec_Spell_Crit == 1 then decimals = "%.1f%%"
	elseif options.Dec_Spell_Crit == 2 then decimals = "%.2f%%"
	else decimals = "%.3f%%" end
	
	if options.Display_Simulate then liveCrit = " > " .. (decimals):format(AddonTable.spellCrit)
	else liveCrit = "" end	
	
	if AddonTable.Band(EB, Percentage) then returnText = (decimals):format(AddonTable.critSpellChance) .. AddonTable.callofThunder .. AddonTable.devastation .. liveCrit end
	if AddonTable.Band(EB, Rating) then returnText = critSpellRating .. liveCrit end
	if AddonTable.Band(EB, Both) then  returnText = (decimals):format(AddonTable.critSpellChance) .. AddonTable.callofThunder .. AddonTable.devastation .. " (" .. critSpellRating .. ")" .. liveCrit end	
	if returnText == nil then returnText = "" end

	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Critical vs Boss
function AddonTable.FunctionList.SpellCritBoss(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local levelDifference = 0
	local critAura = 1.8
	local returnText
	local decimals

	levelDifference = AddonTable.targetLevel - AddonTable.playerLevel
	if levelDifference <= 0 then
		levelDifference = 0
		critAura = 0
	elseif levelDifference >= 3 then
		critAura = 1.8
	end
	
	AddonTable.critSpellBase = AddonTable.critSpellBase - levelDifference - critAura
	AddonTable.critSpellChance = AddonTable.critSpellChance - levelDifference - critAura
	
	if AddonTable.critSpellChance < 0 then AddonTable.critSpellChance = 0 end
	if AddonTable.critSpellBase < 0 then AddonTable.critSpellBase = 0 end
	
	if options.Dec_Spell_Crit_Boss == 0 then decimals = "%.0f%%"
	elseif options.Dec_Spell_Crit_Boss == 1 then decimals = "%.1f%%"
	elseif options.Dec_Spell_Crit_Boss == 2 then decimals = "%.2f%%"
	else decimals = "%.3f%%" end	
	
	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(AddonTable.critSpellChance) .. AddonTable.callofThunder .. AddonTable.devastation end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(AddonTable.critSpellBase) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(AddonTable.critSpellChance) .. AddonTable.callofThunder .. AddonTable.devastation .. " (" .. (decimals):format(AddonTable.critSpellBase) .. ")" end	
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Haste
function AddonTable.FunctionList.HasteCaster(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Percent_Rating
	local hasteSpell = GetHaste()
	local hasteRating = GetCombatRating(CR_HASTE_SPELL)
	local hasteBonus = GetCombatRatingBonus(CR_HASTE_SPELL)
	local returnText
	local decimals
	
	hasteBonus = hasteBonus + AddonTable.castHaste + AddonTable.earthMother + AddonTable.eleMasteryHaste + AddonTable.Enlightenment + AddonTable.NetherwindPresence +
				 AddonTable.borrowedTime + AddonTable.maelstromWeapon + AddonTable.naturesGrace + AddonTable.CelestialFocus + AddonTable.improvedMoonkin + AddonTable.swiftRet + AddonTable.hiddenHaste + 
				 AddonTable.berserkering
	
	if options.Display_Basic then hasteSpell = GetHaste() end
	
	if options.Dec_Spell_Haste == 0 then decimals = "%.0f%%"
	elseif options.Dec_Spell_Haste == 1 then decimals = "%.1f%%"
	elseif options.Dec_Spell_Haste == 2 then decimals = "%.2f%%"
	else decimals = "%.3f%%" end	

	if AddonTable.Band(EB, Percentage) then returnText = (decimals):format(hasteBonus) end
	if AddonTable.Band(EB, Rating) then returnText = hasteRating end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(hasteBonus) .. " (" .. hasteRating .. ")" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Hit
function AddonTable.FunctionList.SpellHit(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Percent_Rating
	local returnText
	local decimals
	local capColor = ""

	if AddonTable.hitSpell == nil then AddonTable.hitSpell = 0 end
	if AddonTable.hitSpellRating == nil then AddonTable.hitSpellRating = 0 end
	if AddonTable.hitSpell >= 17 then capColor = AddonTable.greenText end
	
	if options.Dec_Spell_Hit == 0 then decimals = "%.0f%%"
	elseif options.Dec_Spell_Hit == 1 then decimals = "%.1f%%"
	elseif options.Dec_Spell_Hit == 2 then decimals = "%.2f%%"
	else decimals = "%.3f%%" end	

	if AddonTable.Band(EB, Percentage) then returnText = capColor .. (decimals):format(AddonTable.hitSpell) end
	if AddonTable.Band(EB, Rating) then returnText = AddonTable.hitSpellRating end
	if AddonTable.Band(EB, Both) then returnText = capColor .. (decimals):format(AddonTable.hitSpell) .. " |r(" .. AddonTable.hitSpellRating .. ")" end	
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Miss
function AddonTable.FunctionList.SpellMiss(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Level_Same_Boss
	local returnText, decimals, liveMiss
	
	local missSameLevel = 3
	local missBossLevel = 17
	
	if AddonTable.hitSpell == nil then AddonTable.hitSpell = 0 end
	if AddonTable.hitSpellRating == nil then AddonTable.hitSpellRating = 0 end
	
	missSameLevel = (missSameLevel - AddonTable.hitSpell)
	missBossLevel = (missBossLevel - AddonTable.hitSpell)
	
	if missSameLevel < 0 then missSameLevel = 0
	elseif missSameLevel > 100 then missSameLevel = 100 end
	if missBossLevel < 0 then missBossLevel = 0
	elseif missBossLevel > 100 then missBossLevel = 100 end
	
	if options.Dec_Spell_Miss == 0 then decimals = "%.0f%%"
	elseif options.Dec_Spell_Miss == 1 then decimals = "%.1f%%"
	elseif options.Dec_Spell_Miss == 2 then decimals = "%.2f%%"
	else decimals = "%.3f%%" end
	
	if options.Display_Simulate then liveMiss = " > " .. (decimals):format(AddonTable.spellMissTracker)
	else liveMiss = "" end	

	if AddonTable.Band(EB, SameLevel) then returnText = (decimals):format(missSameLevel) .. liveMiss end
	if AddonTable.Band(EB, BossLevel) then returnText = (decimals):format(missBossLevel) .. liveMiss end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(missSameLevel) .. " |r(" .. (decimals):format(missBossLevel) .. ")" .. liveMiss end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- MP2
function AddonTable.FunctionList.ManaRegen(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Regen_Normal_Casting
	local returnText
	local decimals
	
	if options.Display_Basic then
		AddonTable.regenBase = AddonTable.regenBaseBasic
		AddonTable.regenCasting = AddonTable.regenCastingBasic
	end
	
	if options.Dec_Spell_MP2 == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_MP2 == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_MP2 == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Regen) then returnText = (decimals):format(AddonTable.regenBase) end
	if AddonTable.Band(EB, Casting) then returnText = (decimals):format(AddonTable.regenCasting) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(AddonTable.regenBase) .. " |r(" .. (decimals):format(AddonTable.regenCasting) .. ")" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- MP5
function AddonTable.FunctionList.MP5(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Regen_Normal_Casting
	local returnText
	local decimals
	
	if options.Display_Basic then
		AddonTable.regenBase = AddonTable.regenBaseBasic
		AddonTable.regenCasting = AddonTable.regenCastingBasic
	end	

	AddonTable.regenBase = (AddonTable.regenBase / 2) * 5
	AddonTable.regenCasting = (AddonTable.regenCasting / 2) * 5
	
	if options.Dec_Spell_MP5 == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_MP5 == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_MP5 == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Regen) then returnText = (decimals):format(AddonTable.regenBase) end
	if AddonTable.Band(EB, Casting) then returnText = (decimals):format(AddonTable.regenCasting) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(AddonTable.regenBase) .. " |r(" .. (decimals):format(AddonTable.regenCasting) .. ")" end
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Spell Penetration
function AddonTable.FunctionList.SpellPenetration(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local spellPenetration = GetSpellPenetration()
	local returnText
	local decimals	
	
	if options.Dec_Spell_Pen == 0 then decimals = "%.0f"
	elseif options.Dec_Spell_Pen == 1 then decimals = "%.1f"
	elseif options.Dec_Spell_Pen == 2 then decimals = "%.2f"
	else decimals = "%.3f" end	

	if AddonTable.Band(EB, Enhanced) then returnText = (decimals):format(spellPenetration) end
	if AddonTable.Band(EB, Base) then returnText = (decimals):format(spellPenetration) end
	if AddonTable.Band(EB, Both) then returnText = (decimals):format(spellPenetration) .. " |r(" .. (decimals):format(spellPenetration) .. ")" end	
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------
